Draft PolarArray/ru

From FreeCAD Documentation
Jump to navigation Jump to search
This page is a translated version of the page Draft PolarArray and the translation is 12% complete.
Outdated translations are marked like this.
Other languages:
Deutsch • ‎English • ‎français • ‎italiano • ‎русский
Arrow-left.svg Draft Draft2Sketch.svg Draft to Sketch Назад:
Далее: Link Array Draft LinkArray.svg Arrow-right.svg

Draft PolarArray.svg Draft PolarArray

Расположение в меню
Draft → Polar array
Верстаки
Draft
Быстрые клавиши
отсутствуют
Представлено в версии
0.19
См. также
Array, CircularArray, PathArray, PointArray, Clone


Описание

The Draft PolarArray.svg Draft PolarArray tool creates an array from a selected object placing the copies along a circumference.

This tool can be used on any object that has a Part TopoShape, meaning 2D shapes created with the Draft Workbench, but also 3D solids created with other workbenches, for example, Part, PartDesign, or Arch. It can also create App Links instead of simple copies.

Draft PolarArray example.png

A polar array of an object.


Usage

  1. Select the object that you wish to array.
  2. Press the Draft PolarArray.svg Polar array button. If no object is selected, you will be invited to select one before proceeding.
  3. The task panel is launched where you can select the polar angle, the number of elements, and the center of the axis of rotation.
  4. You can click on the 3D view to simultaneously set the position of the center of rotation, and complete the command. Otherwise, just press Enter or the OK button to complete the operation.

Notes

  • By default, the axis of rotation is the positive Z axis (0, 0, 1). This can be changed in the property editor after the object is created.
  • Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.
  • This command creates the same parametric "Array" object as the one created with the Draft OrthoArray.svg OrthoArray and Draft CircularArray.svg CircularArray tools. Therefore, the array can be converted to orthogonal, polar, or circular by changing its DataArray Type property.

Options

These are the options displayed in the task panel.

  • Polar angle: the angle which determines where the last element of the array will be placed in the polar arrangement. The angle is positive in the counter-clockwise direction, and negative in the clockwise direction.
  • Number of elements: the number of elements in the array. Minimum of 2, maximum of 99.
  • Center of rotation: the coordinates through which the axis of rotation goes through.
  • Reset point: it resets the center of rotation to the origin (0, 0, 0).
  • Fuse: if it is checked, the resulting objects in the array will fuse together if they touch each other. This only works if Link array is unchecked.
  • Link array: if it is checked, the resulting array will be a "Link array". This array internally uses App Link objects, so it is more efficient when handling many copies of complex shapes. However, in this case, the objects cannot be fused together.
  • Press Esc or the Cancel button to abort the current command.

Note: if a Link array is created, this object cannot be converted to a regular array. And similarly, a regular array cannot be converted to a Link array. Therefore, you must choose the type of array that you want at creation time.

Properties

A PolarArray object internally is the same object produced with the Draft OrthoArray.svg OrthoArray tool. It is based on Part Feature (Part::Feature class), and thus shares all properties of the latter.

See the Draft OrthoArray.svg OrthoArray tool for the complete description of the properties. All properties apply, except for those under the Orthogonal array and Circular array groups.

Scripting

See also: Draft API and FreeCAD Scripting Basics.

The PolarArray tool can be used in macros and from the Python console by using the following function.

Older call:

array = makeArray(baseobject, center, totalangle, totalnum, use_link=False)

New call:

array = make_polar_array(base_object,
                         number=5, angle=360, center=App.Vector(0, 0, 0),
                         use_link=True)
  • Creates an "Array" object from the base_object.
    • number is the number of copies in the polar pattern, including the original object.
    • angle is the angle of the polar arc in degrees.
    • center is a vector that defines the center of the array pattern.
    • If use_link is true the created copies will be App Links and not regular copies.

Пример:

import FreeCAD as App
import Draft

doc = App.newDocument()

tri = Draft.make_polygon(3, 600)
center = App.Vector(-1600, 0, 0)

array = Draft.make_polar_array(tri, 8, 270, center)
doc.recompute()

Scripting, non-parametric array

When using the Draft PolarArray.svg PolarArray tool, a parametric "Array" object is created. This can be scripted as described in the previous section.

However, to obtain standalone copies of the base object, the simple Draft.array function can be used. This will create simple copies, not a new parametric object.

To create a polar array, use it like this:

array_list = array(objectslist, center, angle, number)
  • Creates an array from the objects contained in objectslist, which can be a single object or a list of objects.
    • In case of a polar array, center defines the center of the array circle, angle is the angle of the arc in degrees to cover with copies, and number is the number of copies to arrange on the circular arc, not including the original object.
    • array_list is returned with the new copies. It is either a single object or a list of objects, depending on the input objectslist.

This function internally uses Draft.rotate() with copy=True.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

tri = Draft.make_polygon(3, 600)
center = App.Vector(-3200, 0, 0)

array_list = Draft.array(tri, center, 180, 5)
doc.recompute()
Arrow-left.svg Draft Draft2Sketch.svg Draft to Sketch Назад:
Далее: Link Array Draft LinkArray.svg Arrow-right.svg